<?
/*\
  /  This is a part of PhFiTo (aka PHP Fido Tosser)
 /   
/    Copyright (c) Alex Kocharin, 2:50/13
\*/

require_once "F_utils.php";

class C_opusbase
{
	var $_list;
	var $path;
	var $extended_syntax;
	var $allscan_present;

	function C_opusbase()
	{
		$this->extended_syntax = false;
		$this->allscan_present = false;
	}
	
	function OpenBase($path)
	{
		$array = array();
		$this->path = $path;
		if ($dir = @opendir($path)):
			while($file = readdir($dir)):
			if (preg_match('/[0-9]+\.msg/i',$file)):
				@$array[(int)strtok($file,'.')] = $file;
			endif;
			endwhile;
			uksort($array,'_int_sort');
//			while (list($key,$v) = each($array)) print "$key => $v\n";
			$this->_list = array_values($array);
//			foreach($this->_list as $f) print "$f\n";
			return 1;
		else:
			return 0;
		endif;
	}

	function GetNumMsgs()
	{
		return sizeof($this->_list);
	}

	function ReadMsgHeader($msg)
	{
		$file = $this->_list[$msg-1];
		$f = fopen($this->path.'/'.$file,'r');
		$result = new C_msgheader;
		$result->From = fgetasciiz($f);
		fseek($f,36);
		$result->To = fgetasciiz($f);
		fseek($f,72);
		$result->Subj = fgetasciiz($f);
		fseek($f,144);
		$result->WDate = Fts_date_to_unix(fgetasciiz($f));
		$result->ADate = 0;
		fseek($f,186);
		$result->Attrs = FTS_to_Flag(fgetint($f,2));
		fclose($f);
		return $result;
	}

	function ReadMsgBody($msg)
	{
		$file = $this->_list[$msg-1];
		$size = filesize($this->path.'/'.$file);
		$f = fopen($this->path.'/'.$file,'r');
		fseek($f,0xbe);
		$result = fread($f,$size-0xbe);
		fclose($f);
		return $result;
	}
	
	function SetAttr($msg,$attr)
	{
		$attr = Flag_to_FTS($attr);
		$file = $this->_list[$msg-1];
		$f = fopen($this->path.'/'.$file,'r+');
		fseek($f,0xba);
		fputint($f,2,$attr);
		fclose($f);
	}
	
	function CloseBase()
	{
		$this->_list = array();
	}

	function WriteMessage($header,$message)
	{
		if ($sz = sizeof($this->_list))
			{ $num = (int)strtok($this->_list[$sz-1],'.'); }
		else { $num = 1; }
		while (file_exists($file = $this->path.'/'.$num.'.msg')) $num++;
		$f = fopen($file,'w');
		if (strlen($header->From)>36) $header->From = substr($header->From,0,36);
		fputstr($f,$header->From,36);
		if (strlen($header->To)>36) $header->To = substr($header->To,0,36);
		fputstr($f,$header->To,36);
		if (strlen($header->Subj)>72) $header->Subj = substr($header->Subj,0,72);
		fputstr($f,$header->Subj,72);
		fputstr($f,$header->WDate?date('d M y  H:i:s',$header->WDate):date('d M y  H:i:s'),20);
		fwrite($f,chr(0).chr(0));
		$fromaddr = strtok($header->FromAddr,'@');
		$fz = strtok($header->FromAddr,':');
		$fn = strtok('/');
		$ff = strtok('.');
		$fp = strtok(chr(0));
		if (!$fp) $fp = 0;
		$toaddr = strtok($header->ToAddr,'@');
		$tz = strtok($header->ToAddr,':');
		$tn = strtok('/');
		$tf = strtok('.');
		$tp = strtok(chr(0));
		if (!$tp) $tp = 0;
		fputint($f,2,$tf);
		fputint($f,2,$ff);
		fwrite($f,chr(0).chr(0));
		fputint($f,2,$fn);
		fputint($f,2,$tn);
		fputint($f,2,$tz);
		fputint($f,2,$fz);
		fputint($f,2,$tp);
		fputint($f,2,$fp);
		fwrite($f,chr(0).chr(0));
		fputint($f,2,Flag_to_FTS($header->Attrs));
		fwrite($f,chr(0).chr(0));
		fwrite($f,$message.chr(0));
		fclose($f);
		@chmod($file,0666);
	}

	function CreateBase($path)
	{
		mkdir($path);
		@chmod($path,0777);
		return 1;
	}
}

function _int_sort($a,$b)
{
	if ($a<$b) return -1;
	if ($a>$b) return 1;
	return 0;
}

?>
