<?
/*\
  /  This is a part of PhFiTo (aka PHP Fido Tosser)
 /   
/    Copyright (c) Alex Kocharin, 2:50/13
\*/

require_once "F_utils.php";

class C_squishbase
{
	var $_idx;
	var $_base;
	var $_lr;
	var $header;
	var $extended_syntax;
	var $allscan_present;

	function C_squishbase()
	{
		$this->extended_syntax = false;
		$this->allscan_present = false;
	}
	
	function OpenBase($path)
	{
		if (($this->_idx = @fopen($path.'.sqi','r+')) &&
		   ($this->_base = @fopen($path.'.sqd','r+'))):
			$this->_lr = @fopen($path.'.sql','r+');
			$this->header = new SqBaseHeader($this->_base);
			return 1;
		else:
			$this->CloseBase();
			return 0;
		endif;
	}

	function GetNumMsgs()
	{
		return $this->header->num_msg;
	}

	function SetAttr($msg,$attr)
	{
		$attr = $this->_flag_to_sq($attr);
		fseek($this->_idx,$msg*12-12);
		$pos = fgetint($this->_idx,4);
		fseek($this->_base,$pos+28);
		fputint($this->_base,4,$attr);
	}
	
	function ReadMsgHeader($msg)
	{
		fseek($this->_idx,$msg*12-12);
		$pos = fgetint($this->_idx,4);
		$result = new C_msgheader;
		fseek($this->_base,$pos+28);
		$rq = fgetint($this->_base,4);
		$result->Attrs = $this->_sq_to_flag($rq);
		$result->From = fgetasciiz($this->_base);
		fseek($this->_base,$pos+68);
		$result->To = fgetasciiz($this->_base);
		fseek($this->_base,$pos+76+28);
		$result->Subj = fgetasciiz($this->_base);
		fseek($this->_base,$pos+176);
		$z = fgetint($this->_base,2);
		$n = fgetint($this->_base,2);
		$f = fgetint($this->_base,2);
		$p = fgetint($this->_base,2);
		$result->FromAddr = $z.":".$n."/".$f.($p?'.'.$p:'');
		$z = fgetint($this->_base,2);
		$n = fgetint($this->_base,2);
		$f = fgetint($this->_base,2);
		$p = fgetint($this->_base,2);
		$result->ToAddr = $z.":".$n."/".$f.($p?'.'.$p:'');
		fseek($this->_base,$pos+28+164);
		$result->WDate = SCOMBO_to_unix(fgetint($this->_base,4));
		$result->ADate = SCOMBO_to_unix(fgetint($this->_base,4));
		return $result;
	}

	function ReadMsgBody($msg)
	{
		fseek($this->_idx,$msg*12-12);
		$pos = fgetint($this->_idx,4);
		fseek($this->_base,$pos+16);
		$len = fgetint($this->_base,4);
		$speclen = fgetint($this->_base,4);
		fseek($this->_base,$pos+28+238);
		$spec = fread($this->_base,$speclen);
		if (ord($spec{$l = (strlen($spec)-1)})==0) $spec = substr($spec,0,$l);
		$msgspec = $speclen?(chr(1).str_replace(chr(1),chr(13).chr(1),substr($spec,1)).chr(13)):'';
		$message = fread($this->_base,$len-$speclen-238);
//		print str_replace("\r","\n",$msgspec.$message);
		return $msgspec.$message;
	}

	function _flag_to_sq($rq)
	{
		$attrs = 0;
		if ($rq & MSG_PVT) $attrs |= 0x00000001;
		if ($rq & MSG_CRA) $attrs |= 0x00000002;
		if ($rq & MSG_RCV) $attrs |= 0x00000004;
		if ($rq & MSG_SNT) $attrs |= 0x00000008;
		if ($rq & MSG_ATT) $attrs |= 0x00000010;
		if ($rq & MSG_TRS) $attrs |= 0x00000020;
		if ($rq & MSG_ORP) $attrs |= 0x00000040;
		if ($rq & MSG_DEL) $attrs |= 0x00000080;
		if ($rq & MSG_LOC) $attrs |= 0x00000100;
		if ($rq & MSG_HLD) $attrs |= 0x00000200;
		if ($rq & MSG_XMA) $attrs |= 0x00000400;
		if ($rq & MSG_FRQ) $attrs |= 0x00000800;
		if ($rq & MSG_RRQ) $attrs |= 0x00001000;
		if ($rq & MSG_RRC) $attrs |= 0x00002000;
		if ($rq & MSG_ARQ) $attrs |= 0x00004000;
		if ($rq & MSG_URQ) $attrs |= 0x00008000;
		if ($rq & MSG_SCN) $attrs |= 0x00010000;
		$attrs |= 0x00020000;
		return $attrs;
	}

	function _sq_to_flag($rq)
	{
		$attrs = 0;
		if ($rq & 0x00000001) $attrs |= MSG_PVT;
		if ($rq & 0x00000002) $attrs |= MSG_CRA;
		if ($rq & 0x00000004) $attrs |= MSG_RCV;
		if ($rq & 0x00000008) $attrs |= MSG_SNT;
		if ($rq & 0x00000010) $attrs |= MSG_ATT;
		if ($rq & 0x00000020) $attrs |= MSG_TRS;
		if ($rq & 0x00000040) $attrs |= MSG_ORP;
		if ($rq & 0x00000080) $attrs |= MSG_DEL;
		if ($rq & 0x00000100) $attrs |= MSG_LOC;
		if ($rq & 0x00000200) $attrs |= MSG_HLD;
		if ($rq & 0x00000400) $attrs |= MSG_XMA;
		if ($rq & 0x00000800) $attrs |= MSG_FRQ;
		if ($rq & 0x00001000) $attrs |= MSG_RRQ;
		if ($rq & 0x00002000) $attrs |= MSG_RRC;
		if ($rq & 0x00004000) $attrs |= MSG_ARQ;
		if ($rq & 0x00008000) $attrs |= MSG_URQ;
		if ($rq & 0x00010000) $attrs |= MSG_SCN;
		return $attrs;
	}
	
	function WriteMessage($header,$message)
	{
		if (strlen($header->From)>36) $header->From = substr($header->From,0,36);
		if (strlen($header->To)>36) $header->To = substr($header->To,0,36);
		if (strlen($header->Subj)>72) $header->Subj = substr($header->Subj,0,72);
		$off = $this->header->end_frame;
		$last = $this->header->last_frame;
		$uid = $this->header->uid;
		fseek($this->_idx,0,2);
		fputint($this->_idx,4,$off);
		fputint($this->_idx,4,$uid);
		fputint($this->_idx,4,SquishHash(strtolower($header->From)));
		fseek($this->_base,$last+4);
		fputint($this->_base,4,$off);
		fseek($this->_base,$off);
		fputint($this->_base,4,0xAFAE4453);
		fputint($this->_base,4,0);
		fputint($this->_base,4,$last);
		$resmsg = '';
		while($message):
			if ($message{0} == chr(1)):
				if ((strcmp(substr($message,1,5),'PATH:')==0) ||
				(strcasecmp(substr($message,1,4),'Via:')==0))
					{ break; };
			else:
				break;
			endif;
			$pos = strpos($message,"\r");
			$resmsg.= substr($message,0,$pos);
			$message = substr($message,$pos+1);
		endwhile;
		$resmsg = chop($resmsg);
		$clen = strlen($resmsg);
		$resmsg.= $message;
		$rq = $header->Attrs;
		$attrs = $this->_flag_to_sq($rq);
/*		$cnt = 0;
		while($line):
		if (strcmp(substr($line,0,1),chr(1))==0):
			$clen+=strlen($line);
		else:
			break;
		endif;
		$line = strtok("\r");
		endwhile;*/
		$lenfr = 238 + strlen($resmsg);
		fputint($this->_base,4,$lenfr);
		fputint($this->_base,4,$lenfr);
		fputint($this->_base,4,$clen);
		fputint($this->_base,2,0);
		fwrite($this->_base,chr(0).chr(0));
		fputint($this->_base,4,$attrs);
		fputstr($this->_base,$header->From,36);
		fputstr($this->_base,$header->To,36);
		fputstr($this->_base,$header->Subj,72);
		$fromaddr = strtok($header->FromAddr,'@');
		$fz = strtok($header->FromAddr,':');
		$fn = strtok('/');
		$ff = strtok('.');
		$fp = strtok(chr(0));
		if (!$fp) $fp = 0;
		$toaddr = strtok($header->ToAddr,'@');
		$tz = strtok($header->ToAddr,':');
		$tn = strtok('/');
		$tf = strtok('.');
		$tp = strtok(chr(0));
		if (!$tp) $tp = 0;
		fputint($this->_base,2,$fz);
		fputint($this->_base,2,$fn);
		fputint($this->_base,2,$ff);
		fputint($this->_base,2,$fp);
		fputint($this->_base,2,$tz);
		fputint($this->_base,2,$tn);
		fputint($this->_base,2,$tf);
		fputint($this->_base,2,$tp);
		fputint($this->_base,4,$header->WDate?unix_to_SCOMBO($header->WDate):unix_to_SCOMBO(mktime()),20);
		fputint($this->_base,4,$header->ADate?unix_to_SCOMBO($header->ADate):0);
		fwrite($this->_base,chr(0).chr(0));
		for ($i=0;$i<=9;$i++) fwrite($this->_base,chr(0).chr(0).chr(0).chr(0));
		fputint($this->_base,4,$uid);
		fputstr($this->_base,$header->WDate?date('d M y  H:i:s',$header->WDate):date('d M y  H:i:s'),20);
		
		fwrite($this->_base,$resmsg);
		
		$this->header->num_msg++;
		$this->header->high_msg++;
		$this->header->uid++;
		$this->header->last_frame = $off;
		$this->header->end_frame = $off + 28 + $lenfr;
		$this->header->WriteHdr($this->_base);
	}

	function CloseBase()
	{
		if ($this->_idx) fclose($this->_idx);
		if ($this->_base) fclose($this->_base);
		if ($this->_lr) fclose($this->_lr);
	}

	function CreateBase($path)
	{
		if (($sqd = fopen($path.'.sqd','w')) &&
			($sqi = fopen($path.'.sqi','w')) &&
			($sql = fopen($path.'.sql','w'))):
				fputint($sqd,2,256);
				fputint($sqd,2,0);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,1);
				fputstr($sqd,$path,80);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,0);
				fputint($sqd,4,256);
				fputint($sqd,4,0);
				fputint($sqd,2,0);
				fputint($sqd,2,256);
				for ($i=0;$i<124;$i++) fwrite($sqd,chr(0));
				fclose($sqd);
				fclose($sqi);
				fclose($sql);
				@chmod($path.'.sqd',0666);
				@chmod($path.'.sqi',0666);
				@chmod($path.'.sql',0666);
				return 1;
		else:
			if (isset($sqd) && $sqd) fclose($sqd);
			if (isset($sqi) && $sqi) fclose($sqi);
			if (isset($sql) && $sql) fclose($sql);
			return 0;
		endif;
	}
}

class SqBaseHeader
{
	var $len;
	var $reserved;
	var $num_msg;
	var $high_msg;
	var $skip_msg;
	var $high_water;
	var $uid;
	var $base;
	var $begin_frame;
	var $last_frame;
	var $free_frame;
	var $last_free_frame;
	var $end_frame;
	var $max_msg;
	var $keep_days;
	var $sz_sqhdr;
	
	function SqBaseHeader($file)
	{
		if ($file === 0):
		else:
		$this->len = fgetint($file,2);
		$this->reserved = fgetint($file,2);
		$this->num_msg = fgetint($file,4);
		$this->high_msg = fgetint($file,4);
		$this->skip_msg = fgetint($file,4);
		$this->high_water = fgetint($file,4);
		$this->uid = fgetint($file,4);
		$this->base = fread($file,80);
		$this->begin_frame = fgetint($file,4);
		$this->last_frame = fgetint($file,4);
		$this->free_frame = fgetint($file,4);
		$this->last_free_frame = fgetint($file,4);
		$this->end_frame = fgetint($file,4);
		$this->max_msg = fgetint($file,4);
		$this->keep_days = fgetint($file,2);
		$this->sz_sqhdr = fgetint($file,2);
		endif;
	}

	function WriteHdr($file)
	{
		fseek($file,0);
		fputint($file,2,$this->len);
		fputint($file,2,$this->reserved);
		fputint($file,4,$this->num_msg);
		fputint($file,4,$this->high_msg);
		fputint($file,4,$this->skip_msg);
		fputint($file,4,$this->high_water);
		fputint($file,4,$this->uid);
		fputstr($file,$this->base,80);
		fputint($file,4,$this->begin_frame);
		fputint($file,4,$this->last_frame);
		fputint($file,4,$this->free_frame);
		fputint($file,4,$this->last_free_frame);
		fputint($file,4,$this->end_frame);
		fputint($file,4,$this->max_msg);
		fputint($file,2,$this->keep_days);
		fputint($file,2,$this->sz_sqhdr);
		fputstr($file,'',124);
	}
}

function SCOMBO_to_unix($scombo)
{
	$hour=(($scombo >> 27) & 31);
	$min=(($scombo >> 21) & 63);
	$sec=(($scombo >> 16) & 31)*2;
	$year=(($scombo >> 9) & 127)+1980;
	$month=(($scombo >> 5) & 15);
	$day=($scombo & 31);
	$res = 0;
	for ($i=16;$i;$i--) { $res.=($scombo >> $i) & 1;}
	$time_p = mktime($hour, $min, $sec, $month, $day, $year);
	return $time_p;
}

function unix_to_SCOMBO($stamp)
{
	$date_msv = split(' ',date('d m y H i s',$stamp));
	$result = ($date_msv[0]);
	$result+= ($date_msv[1] << 5);
	$result+= (($date_msv[2]+($date_msv[2]>79?1900:2000)-1980) << 9);
	$result+= ($date_msv[3] << 27);
	$result+= ($date_msv[4] << 21);
	$result+= (($date_msv[5]/2 & 31) << 16);
	return $result;
}

function SquishHash($f)
{
	$hash = $g = 0;

	for ($p=0; $p<strlen($f); $p++)
	{
		 $hash=($hash << 4) + ord($f{$p});

		 if (($g=($hash & 0xf0000000)) != 0)
		 {
			  $hash |= $g >> 24;
			  $hash |= $g;
		 }
	}

	return ($hash & 0x7fffffff);
}
?>
