<?
/*\
  /  This is a part of PhFiTo (aka PHP Fido Tosser)
 /   
/    Copyright (c) Alex Kocharin, 2:50/13
\*/

include_once "F_utils.php";

function aks_init($module = false, $file = 'config')
{
	GLOBAL $CONFIG;
	GLOBAL $Outbound;
	ignore_user_abort(true);
	@set_time_limit(1200);
	set_error_handler('Error_handler');
	$CONFIG = new C_CONFIG();
	if (($file === false) || is_file($file)) {
		$CONFIG->Open($file,$module);
	} else {
		die("Config not found! Exitting...\n");
	}
	if ($log = $CONFIG->GetVar("lockfile")) {
		$ctime = mktime();
		$time = $CONFIG->GetVar("locktime");
		if ($time === '') $time = 300;
		if (is_file($log)) {
			if ($f = fopen($log,'r')) {
				$ptime = trim(fgets($f));
				fclose($f);
				if (abs(((int)$ptime) - $ctime)>$time) {
					if ($f = fopen($log,'w')) {
						fwrite($f,$ctime);
						fclose($f);
					} else {
						die("Can't create lockfile $log! Exitting...\n");
					}
				} else {
					die("Lockfile $log exists! Exitting...\n");
				}
			} else {
				die("Lockfile $log exists and not readable! Exitting...\n");
			}
		} else {
			if ($f = fopen($log,'w')) {
				fwrite($f,$ctime);
				fclose($f);
			}
		}
	}
	initlog();
	if (isset($CONFIG->Vars['outbound'])):
		include_once "A_common.php";
		$Outbound = new C_BSO_Outbound($CONFIG->Vars['outbound']);
	endif;
}

function aks_done()
{
	GLOBAL $CONFIG, $Outbound;
	donelog();
	$Outbound = '';
	if (function_exists('MysqlConnMgr')) {
		MysqlConnMgr(1);
	}
	if ($log = $CONFIG->GetVar("lockfile")) {
		if (is_file($log)) {
			unlink($log);
		}
	}
	$CONFIG = '';
}

function param_split($line)
{
	$num = 0;
	$kav = 0;
	$emp = 1;
	$result = array('');
	$s = strlen($line);
	for($i=0;$i<$s;$i++):
		switch($line{$i}):
			case("\""):
				if ($kav):
					$kav = 0;
					$emp = 0;
				else:
					if (!$emp):
						$result[++$num] = '';
						$emp = 1;
					endif;
					$kav = 1;
				endif;
				break;
			case(" "):
				if ($kav):
					$result[$num].= ' ';
					$emp = 0;
				else:
					if (!$emp):
				   		$result[++$num] = '';
						$emp = 1;
					endif;
				endif;
				break;
			default:
				$result[$num].= $line{$i};
				$emp = 0;
		endswitch;
	endfor;
	return $result;
}

function param_split_esc($line)
{
	$num = 0;
	$kav = 0;
	$emp = 1;
	$esc = 0;
	$result = array('');
	$s = strlen($line);
	for($i=0;$i<$s;$i++):
		switch($line{$i}):
			case("\\"):
				if ($esc) {
					$result[$num] .= "\\";
					$esc = 0;
				} else {
					$esc = 1;
				}
				break;
			case("\""):
				if ($esc) {
					$result[$num] .= "\"";
					$esc = 0;
				} else {
					if ($kav):
						$kav = 0;
						$emp = 0;
					else:
						if (!$emp):
							$result[++$num] = '';
							$emp = 1;
						endif;
						$kav = 1;
					endif;
				}
				break;
			case(" "):
				if ($esc) {
					$result[$num] .= " ";
					$esc = 0;
				} else {
					if ($kav):
						$result[$num].= ' ';
						$emp = 0;
					else:
						if (!$emp):
					   		$result[++$num] = '';
							$emp = 1;
						endif;
					endif;
				}
				break;
			default:
				$result[$num].= $line{$i};
				$emp = 0;
		endswitch;
	endfor;
	return $result;
}

function join_attrs($old,$new)
{
	for($i=0;$i<strlen($new);$i++) {
		$inv = 0;
		if ($new{$i}=='!') {
			$inv = 1;
			if (++$i >= strlen($new)) break;
		}
		if ($inv) {
			if (strpos($old,$new{$i}) !== false) 
				$old = str_replace($new{$i},'',$old);
		} else {
			if (strpos($old,$new{$i}) === false) 
				$old .= $new{$i};
		}
	}
	return $old;
}

class C_configfile_reader
{
	var $file;
	var $cache;
	var $nofile;
	var $iflvl;
	var $Levels;
	var $LvlsPs;
	var $linenum;
	var $interpret;
	var $filename;
	var $updatecache;
	var $cachevalid;
	
	function C_configfile_reader($filename = false)
	{
		list($filename,$cache) = $this->GetConfigFileName($filename);
		$this->filename = $filename;
		if ($filename !== false):
			$this->file = fopen($filename,'r');
		else:
			$this->nofile = 1;
		endif;
		$this->cache = false;
		$this->updatecache = 0;
		$this->cachevalid = 0;
		if ($cache !== false) {
			$this->OpenCache($cache);
		}
		$this->iflvl = 0;
		$this->Levels[0] = 1;
		$this->LvlsPs[0] = 1;
		$this->interpret = 1;
	}

	function OpenCache($cache)
	{
		GLOBAL $CONFIG;
		if (!$this->file) return 0;
		if ($this->cache = @fopen($cache,"rb")) {
			$timeorig = filemtime($this->filename);
			$time = fgetasciiz($this->cache);
			$mod = fgetasciiz($this->cache);
			$ver = fgetasciiz($this->cache);
		} else {
			$timeorig = 1;
		}
		if ($timeorig) {
			if ((!$this->cache) || (in_array(basename($this->filename),$CONFIG->NoCache)) || ($timeorig != $time) || ($CONFIG->_module != $mod) || (VERSION != $ver)) {
				$this->cache = fopen($cache,'wb');
				if ($this->cache) {
					unset($CONFIG->NoCache[$cache]);
					$this->updatecache = 1;
					fputasciiz($this->cache,$timeorig);
					fputasciiz($this->cache,$CONFIG->_module);
					fputasciiz($this->cache,VERSION);
				} else {
					$this->updatecache = 0;
				}
			} else {
				$this->cachevalid = 1;
			}
		}
	}

	function ReadPair($line = false)
	{
		if ($line !== false) return $this->_readstr($line);
		if ($this->cachevalid) {
			return $this->_readbin();
		}
		while(1) {
			$line = $this->_readstr();
			if ($line === false) return false;
			if ($line = trim($line)) {
				$arr = split(" ",$line,2);
				$arr[0] = strtolower(rtrim($arr[0]));
				$arr[1] = isset($arr[1])?ltrim($arr[1]):'';
				if ($this->updatecache) {
					$this->_writebin($arr[0],$arr[1]);
				}
				return $arr;
			}
		}
	}
	
	function GetConfigFileName($filename)
	{
		GLOBAL $CONFIG;
		$array = split(' ',$filename);
		$fname = false;
		$cache = false;
		for($i=0,$s=sizeof($array);$i<$s;$i++) {
			if ($array[$i] == '-b') {
				$i++;
				if (isset($array[$i])) {
					$cache = $array[$i];
				} else {
					return array(false,false);
				}
			} else {
				if ($fname === false) {
					$fname = $array[$i];
				} else {
					return array(false,false);
				}
			}
		}
		return array($fname,$cache);
	}

	function _writebin($key,$val)
	{
		fwrite($this->cache,$key.chr(0).$val.chr(0));
	}

	function _readbin()
	{
		if (feof($this->cache)) return false;
		$arr[] = fgetasciiz($this->cache);
		if (feof($this->cache)) return false;
		$arr[] = fgetasciiz($this->cache);
		return $arr;
	}

	function _readstr($line = false)
	{
		if (!$this->nofile):
			if (!$this->file) return false;
			$line = fgets($this->file,10240);
			$this->linenum++;
		endif;
		if (!$line) return false; 
		$line = trim($line);
		if ($this->interpret) {
			$line = $this->read_and_translate($line);
		}

		if (strcmp(substr($line,0,3),'if ')==0):
			if ($this->Levels[$this->iflvl++]):
				$this->LvlsPs[$this->iflvl] = $this->Levels[$this->iflvl] = $this->is_equal(substr($line,3));
			else:
				$this->Levels[$this->iflvl] = 0;
				$this->LvlsPs[$this->iflvl] = 1;
			endif;
			return '';
		elseif (strcmp(substr($line,0,7),'elseif ')==0):
			if (!$this->LvlsPs[$this->iflvl]):
				$this->LvlsPs[$this->iflvl] = $this->Levels[$this->iflvl] = $this->is_equal(substr($line,7));
			else:
#				$this->Levels[$this->iflvl] = $this->LvlsPs[$this->iflvl] = 0;
				$this->Levels[$this->iflvl] = 0;
			endif;
			return '';
		elseif (strcmp(substr($line,0,4),'else')==0):
			if (!$this->LvlsPs[$this->iflvl]):
				$this->LvlsPs[$this->iflvl] = $this->Levels[$this->iflvl] = 1;
			else:
#				$this->Levels[$this->iflvl] = $this->LvlsPs[$this->iflvl] = 0;
				$this->Levels[$this->iflvl] = 0;
			endif;
			return '';
		elseif (strcmp(strtok($line,' '),'endif')==0):
			$this->iflvl--;
			return '';
		elseif (strcasecmp(strtok($line,' '),'interpret')==0):
			$this->interpret = strtok(' ');
			return '';
		elseif ($this->Levels[$this->iflvl]):
			return $line;
		else:
			return '';
		endif;
	}

	function is_equal($str)
	{
		if (($p = strpos($str,'=='))===false) return 1;
		$a = substr($str,0,$p);
		$b = substr($str,$p+2);
		return (strcasecmp($a,$b)==0);
	}
	
	function insert_constant($spec,$chars,$b,$e)
	{
		GLOBAL $CONFIG;
		$const = substr($chars,$b+1,$e-$b-1);
		$value = isset($CONFIG->Constants[$const])?$CONFIG->Constants[$const]:'';
		$spec_n = substr($spec,0,$b);
		$s = strlen($value);
		for ($i=0;$i<$s;$i++) $spec_n.= chr(0);
		$spec_n.= substr($spec,$e+1);
		$chars = substr($chars,0,$b).$value.substr($chars,$e+1);
		return array($spec_n,$chars);
	}

	function read_and_translate($line)
	{
		$ls = $rs = false;
		$l_chars = '';
		$l_spec = '';
		$spec = 0;
		$splen = 0;

		$s = strlen($line);
		for ($i=0;$i<$s;$i++):
			$c = $line{$i};
			if ($c === '\\'):
				if ($spec):
					$spec = 0;
					$l_chars.= '\\';
					$l_spec.= chr(0);
					$splen++;
				else:
					$spec = 1;
				endif;
			elseif(($b = ($c === '[')) || ($c === ']')):
				if ($spec):
					$l_chars.= $c;
					$l_spec.= chr(0);
					$splen++;
					$spec = 0;
				else:
					if ($b):
						if ($ls === false){ $ls = $splen; };
					else:
						if ($rs === false){ $rs = $splen; };
					endif;
					$l_chars.= chr(0);
					$l_spec.= $c;
					$splen++;
				endif;
			elseif($c === '#'):
				if ($spec):
					$l_chars.= $c;
					$l_spec.= chr(0);
					$splen++;
					$spec = 0;
				else:
					break;
				endif;
			else:
				if ($spec):
					$l_chars.='\\';
					$l_spec.= chr(0);
					$splen++;
					$spec = 0;
				endif;
				$l_chars.= $c;
				$l_spec.= chr(0);
				$splen++;
			endif;
		endfor;
		if ($spec):
			$l_chars.='\\';
			$l_spec.= chr(0);
			$splen++;
			$spec = 0;
		endif;
		$s = $splen;
		$bt = -1;
		$et = -1;
#print $line."\n";
#print str_replace(chr(0),'*',$l_spec)."\n";
#print str_replace(chr(0),'*',$l_chars)."\n";
		if ($ls === false) $ls = 0x7fffffff;
		if ($rs === false) $rs = 0x7fffffff;
		while (true):
			if ($ls == $rs):
				break;
			elseif ($ls < $rs):
				$bt = $ls;
				$et = -1;
				$ls = strpos($l_spec,'[',$ls+1);
				if ($ls === false) { $ls = 0x7fffffff; };
			else:
				$et = $rs;
				if ($bt==-1):
					$rs = strpos($l_spec,']',$rs+1);
					if ($rs === false) { $rs = 0x7fffffff; };
				else:
					list($l_spec,$l_chars) = $this->insert_constant($l_spec,$l_chars,$bt,$et);
					$ls = strpos($l_spec,'[');
					$rs = strpos($l_spec,']');
					if ($ls === false) $ls = 0x7fffffff;
					if ($rs === false) $rs = 0x7fffffff;
					$bt = -1;
				endif;
			endif;
		endwhile;
		$result = '';
		$o = false;
		$l = strpos($l_chars,chr(0));
		while ($l!==false):
			$result.= substr($l_chars,0,$l).$l_spec{$l};
			$o = $l;
			$l = strpos($l_chars,chr(0),$l+1);
		endwhile;
		if ($o === false) $o = 0;
		$result.= substr($l_chars,$o);
	//	$line=trim(strcmp(substr($line,0,1),'#')==0?'':strtok($line,'#'));
		return $result;
	}

	function Close()
	{
		if ($this->file) fclose($this->file);
	}
}

class C_UserDef
{
	var $Vars;
	var $exists;
	
	function OpenCfg($Base,$UID)
	{
		$this->exists = 0;
		$reader = new C_configfile_reader($Base);
		while (($pair = $reader->ReadPair())!==false)
		{
			list($key,$value) = $pair;
			if ($key == 'user'):
				if ($loaduser = (strcmp($UID,$value)==0)):
					$this->Vars['uid'] = $value;
					$this->exists = 1;
				endif;
			elseif($loaduser):
				$i = '';
				while (@$this->Vars[$key.$i]) $i++;
				$this->Vars[$key.$i] = $value;
			endif;
		}
		$reader->Close();
	}
}

class C_Links
{
	var $_filename;
	var $_line;
	var $LinkDef;
	var $Vals;
	var $Vals_loc;
	var $Vals_defloc;
	var $Curr_ms;
	var $Curr_ms_loc;
	
	function OpenCfg($filename)
	{
		$linknew = 0;
		$this->_filename = $filename;
		$reader = new C_configfile_reader($filename);
		while (($pair = $reader->ReadPair())!==false)
		{
			@list($key,$value) = $pair;
			if ($key == 'linkdefaults'):
				$this->Addlink($linknew);
				$linknew=0;
			elseif ($key == 'link'):
				$this->_line = $reader->linenum;
				$this->Addlink($linknew);
				$linknew=1;
				$this->Curr_ms['sysop']=$value;
			else:
				$i = '';
				while (isset($this->Curr_ms[$key.$i])) $i++;
				$this->Curr_ms[$key.$i] = $value;
				$this->Curr_ms_loc[$key.$i] = array($filename,$reader->linenum,true);
			endif;
		}
		$this->AddLink($linknew);
		$reader->Close();
		unset($this->Curr_ms);
	}

	function AddLink($linknew)
	{
		if ($this->Curr_ms)
		{
			if ($linknew) {
				if ($this->LinkDef) {
					reset($this->LinkDef);
					while (list($key,$value)=each($this->LinkDef)) {
						if (!isset($this->Curr_ms[$key])) {
							$this->Curr_ms[$key] = $value;
						}
					}
				}
				$aka = $this->Curr_ms['aka'];
				$this->Vals[$aka]=$this->Curr_ms;
				$this->Vals_loc[$aka]=$this->Curr_ms_loc;
				$this->Vals_defloc[$aka] = array($this->_filename,$this->_line,false);
			} else {
				reset($this->Curr_ms);
				while (list($key,$value)=each($this->Curr_ms)) {
					$this->LinkDef[$key]=$value;
				}
			}
		}
		$this->Curr_ms = array();
	}
}

class C_AreaDef
{
	var $EchoTag;
	var $Path;
	var $Status;
	var $Linkattr;
	var $Defattr;
	var $Defattr_up;
	var $Defattr_orig;
	var $Linkattr_orig;
	var $Linkattr_up;
	var $Options;
	var $GroupDescr;
	var $l_file;
	var $l_line;
	var $lt_file;
	var $lt_line;
	var $DefFragment;
	var $Fragments;

	function C_AreaDef($line,$group=false)
	{
		$vkh = 0;
		$line2 = '';
		if ($line) {
			for ($i=0; $i<strlen($line); $i++) {
				$c = substr($line,$i,1);
				if (strcmp($c,'"')==0) {
					$vkh++;
					$c = ($vkh%2?chr(2):'');
				} elseif ((strcmp(substr($line,$i,1),' ')==0) && ($vkh%2)) {
					$c=chr(1);
				}
				$line2.=$c;
			}
			$msv = split(' ',$line2);
			$msv2 = array();
			$s = sizeof($msv);
			for ($i=0;$i<$s;$i++) {
				if ($msv[$i] !== '') {
					$msv2[] = str_replace(chr(1),' ',str_replace(chr(2),'',$msv[$i]));
				}
			}
			$msv = $msv2;
			unset($msv2);
			if ($group) {
				if (isset($msv[0])) {
					if ((strlen($msv[0])<2)||(strcmp('-',substr($msv[0],0,1))!=0)) {
						$this->GroupDescr = array_shift($msv);
					}
				}
			} else {
				$this->Status = strtolower(array_shift($msv));
				$this->EchoTag = array_shift($msv);
				$this->Path = array_shift($msv);
			}
			$this->Options = array();
	//		$this->Links = array();
			$this->Linkattr = array();
			$this->DefFragment = false;
			$this->Fragments = array();
			for ($i=0;$i<sizeof($msv); $i++) {
				if (strcmp(substr($msv[$i],0,1),'-')==0) {
					$this->Options[$msv[$i]] = $msv[$i+1];
					$i++;
				} else {
					if (!isset($this->Linkattr[$msv[$i]])) {
	//					$this->Links[] = $msv[$i];
						$this->Linkattr[$msv[$i]] = array();
					}
				}
			}
		}
	}

	function SplitModeFragm($omode)
	{
		$mode = $omode;
		$p = strpos($mode,'F');
		if ($p === false) return array($omode,false);
		$remode = substr($mode,0,$p);
		$mode = substr($mode,$p+1);
		$i = 0; 
		$s = strlen($mode);
		while(($i < $s) && (ord('0') <= ord($mode{$i})) && 
			(ord($mode{$i}) <= ord('9'))) $i++;
		if ($i == 0) return array($omode,false);
		$fragm = substr($mode,0,$i);
		$remode .= substr($mode,$i);
		return array($remode,$fragm);
	}

	function GetMode($arr,$emode)
	{
		list($emode,$fragm) = $this->SplitModeFragm($emode);
		$this->Defattr_orig = $emode;
		if ($fragm!==false) $this->DefFragment = $fragm;
		$this->Defattr = join_attrs($this->Defattr,$emode);
		$modes = array();
		for($i=0,$s=sizeof($arr);$i<$s;$i++) {
			$a = split(':',$arr[$i]);
			if (sizeof($a)>1) {
				$m = array_pop($a);
				if (preg_match('/^[a-z!][a-z0-9!]*$/i',$m)) {
					$modes[] = array(join(':',$a),$m);
				}
			}
		}
		if ($modes) {
			foreach($modes as $mode) {
				list($mode[1],$fragm) = $this->SplitModeFragm($mode[1]);
				if ($fragm !== false) $this->Fragments[$mode[0]] = $fragm;
				$this->Linkattr_orig[$mode[0]] = $mode[1];
				if (isset($this->Linkattr[$mode[0]])) {
					$this->Linkattr_up[$mode[0]] = $this->Linkattr[$mode[0]];
				} else {
					$this->Linkattr_up[$mode[0]] = $this->Defattr;
				}
				$this->Linkattr[$mode[0]] = join_attrs($this->Linkattr_up[$mode[0]],$mode[1]);
			}
		}
	}

	function IssetAttr($link,$attr)
	{
		if (!isset($this->Linkattr[$link])) {
			$mode = $this->Defattr;
		} else {
			$mode = $this->Linkattr[$link];
		}
		for($i=strlen($attr)-1;$i>=0;$i--) {
			$c = $attr{$i};
			if (strpos($mode,$c)===false) {
				return false;
			}
		}
		return true;
	}
}

class C_Areas
{
	var $Vals;
	var $Groups;

	function OpenCfg($filename)
	{
		$reader = new C_configfile_reader($filename);
		while (($pair = $reader->ReadPair())!==false)
		{
			list($key,$val) = $pair;
			if ($key == 'echogroup') {
				$arr = split(' ',$val,2);
				$name = $arr[0];
				$descr = isset($arr[1])?$arr[1]:'';
				$this->Groups[$name] = new C_AreaDef($descr,true);
			} else if ($key == 'groupmode' || $key == 'echomode') {
				$arr = split(' ',$val);
				$name = array_shift($arr);
				$a = split(':',$name);
				$emode = '';
				if (sizeof($a)>1) {
					$emode = array_pop($a);
					$name = join(':',$a);
				}
				if ($key == 'groupmode') {
					if (isset($this->Groups[$name])) {
						$this->Groups[$name]->GetMode($arr,$emode);
					}
				} else {
					if (($num = $this->FindAreaNum($name)) != -1) {
						$this->Vals[$num]->GetMode($arr,$emode);
						$this->Vals[$num]->lt_file = $reader->filename;
						$this->Vals[$num]->lt_line = $reader->linenum;
					}
				}
			} else {
				$this->AppendAreaToConf($key.' '.$val,array($reader->filename,$reader->linenum));
			}
		}
		$reader->Close();
	}

	function AppendAreaToConf($line,$loc)
	{
		$num = sizeof($this->Vals);
		$this->Vals[$num] = new C_AreaDef($line);
		$this->Vals[$num]->l_file = $loc[0];
		$this->Vals[$num]->l_line = $loc[1];
		if (isset($this->Vals[$num]->Options['-g'])) {
 			$grp = $this->Vals[$num]->Options['-g'];
			if (isset($this->Groups[$grp])) {
				if ($this->Groups[$grp]->Options) {
					foreach($this->Groups[$grp]->Options as $opt=>$val) {
						if (!isset($this->Vals[$num]->Options[$opt]))
							$this->Vals[$num]->Options[$opt] = $val;
					}
				}
				foreach($this->Groups[$grp]->Linkattr as $link=>$attr) {
					$this->Vals[$num]->Linkattr[$link] = $attr;
					$this->Vals[$num]->Linkattr_up[$link] = $attr;
				}
				$this->Vals[$num]->Defattr = $this->Groups[$grp]->Defattr;
				$this->Vals[$num]->Defattr_up = $this->Groups[$grp]->Defattr;
			}
		}
	}
	
	function FindAreaNum($name)
	{
		if ($this->Vals):
		$sz = sizeof($this->Vals);
		for ($i=0;$i<$sz;$i++)
		{
			if (strcasecmp($this->Vals[$i]->EchoTag,$name)==0):
				return $i;
			endif;
		}
		endif;
		return -1;
	}
}

class C_CONFIG
{
	var $_module;
	var $_mainfile;
	var $Links;
	var $Vars;
	var $Areas;
	var $FAreas;
	var $Constants;
	var $NoCache;
	
	function Open($filename,$module = false)
	{
		GLOBAL $temp_dir;
		define('VERSION','1.1.0');
		$this->_mainfile = $filename;
		$this->_module = substr($module,0,255);
		$this->Links = new C_Links;
		$this->Areas = new C_Areas;
		$this->FAreas = new C_Areas;
		if ($module):
			$this->Constants['module'] = $module;
		else:
			$this->Constants['module'] = 'Unknown';
		endif;
		$this->Constants['version'] = VERSION;
		if ($filename === false) {
			$this->load_defaults();
		} else {
			$this->ReadCfgFile($filename);
		}
		$temp_dir = $this->GetVar('tempdir');
		$this->NoCache = array();
	}

	function load_defaults()
	{
		$this->Vars['logfile'] = 
			'stdout 1234567890QWERTYUIOPLKJHGFDSAZXCVBNM';
		$this->Vars['sysop'] = 'SysOp';
		$this->Vars['address'] = '2:2/9999';
		$this->Vars['system'] = 'Unknown system';
		$this->Vars['location'] = 'Unknown place';
		$this->Vars['tempdir'] = '.';
	}

	function Reload($modified = array())
	{
		GLOBAL $temp_dir;
		$this->NoCache = array();
		foreach($modified as $item) $this->NoCache[] = basename($item);
		$filename = $this->_mainfile;
		$module = $this->_module;
		unset($this->Links);
		$this->Links = new C_Links;
		unset($this->Areas);
		$this->Areas = new C_Areas;
		unset($this->FAreas);
		$this->FAreas = new C_Areas;
		$this->Constants = array();
		if ($module):
			$this->Constants['module'] = $module;
		else:
			$this->Constants['module'] = 'Unknown';
		endif;
		if ($filename === false) {
			$this->load_defaults();
		} else {
			$this->ReadCfgFile($filename);
		}
		$temp_dir = $this->GetVar('tempdir');
	}

	function ReadCfgFile($filename,$cache = false)
	{
		$reader = new C_configfile_reader($filename);
		while (($pair = $reader->ReadPair())!==false)
		{
			list($key,$value) = $pair;
			if ($key == 'set') {
				list($c,$v) = split('=',$value);
				$c = trim($c);
				$v = trim($v);
				if ($c && (strcmp($c{0},'"')==0) && (strcmp($c{strlen($c-1)},'"')==0)):
					$c = substr($c,1,strlen($c)-2);
				endif;
				if ((strcmp($v{0},'"')==0) && (strcmp($v{strlen($v)},'"')==0)) {
					$v = substr($v,1,strlen($c)-2);
				}
				$this->Constants[$c] = $v;
			} else if ($key == 'includelinks') {
				$this->Links->OpenCfg($value);
			} else if ($key == 'includeareas') {
				$this->Areas->OpenCfg($value);
			} else if ($key == 'includefareas') {
				$this->FAreas->OpenCfg($value);
			} else if ($key == 'include') {
				$this->ReadCfgFile($value);
			} else {
				$i = '';
				while (isset($this->Vars[$key.$i])) $i++;
				$this->Vars[$key.$i] = $value;
			}
		}
		$reader->Close();
		unset($reader);
	}

	function SaveCfgFileBin($filename)
	{
		if ($f = @fopen($filename,"w")) {
			fputint($f,strlen(VERSION),1);
			fwrite($f,VERSION);
			fputint($f,strlen($this->_module),1);
			fwrite($f,$this->_module);
			foreach($this->Vars as $key=>$val) {
				$towr = $key.chr(0).$val.chr(0);
				fputint($f,strlen($key)+2+strlen($val),2);
				fwrite($f,$towr);
			}
		}
	}

	function GetVar($param)
	{
		if (isset($this->Vars[$param])) {
			return $this->Vars[$param];
		} else {
			return '';
		}
	}

	function GetLinkVar($addr,$param)
	{
		if (isset($this->Links->Vals[$addr][$param])) {
			return $this->Links->Vals[$addr][$param];
		} else {
			return '';
		}
	}

	function GetArray($param)
	{
		$cnt = '';
		$result = array();
		while(isset($this->Vars[$param.$cnt])) {
			$result[]=$this->Vars[$param.$cnt];
			$cnt++;
		}
		return $result;
	}

	function GetOurAkaFor($link)
	{
		if (isset($this->Links->Vals[$link]['ouraka'])) return $this->Links->Vals[$link]['ouraka'];
		return $this->GetVar('address');
	}
}

function Error_handler($code, $msg, $errfile, $errline, $vars)
{	
	GLOBAL $CONFIG;
	#print "$errfile:$errline:$msg";
	if (isset($CONFIG) && isset($CONFIG->Vars['errlogfile'])): 
		$arr = split(' ',$CONFIG->Vars['errlogfile'],2);
		$file = $arr[0];
		$param = isset($arr[1])?$arr[1]:'';
		$writelog = 1;
		$errcrc = dechex(crc32("$code $msg $errfile $errline"));
		if ($writelog && (strstr($param,'-h')) && (error_reporting()==0)) $writelog = 0;
		if ($writelog && (strstr($param,'-q')) && is_readable($file)):
			if ($f = @fopen($file,'r')):
				while($line = fgets($f,1024)):
					if (strcasecmp('+'.$errcrc,trim($line))==0):
						$writelog = 0;
						break;
					endif;
				endwhile;
				fclose($f);
			endif;
		endif;
		if ($writelog && ($f = fopen($file,'a'))):
			fwrite($f,"+$errcrc\n");
			fwrite($f,"Error code: $code\n");
			fwrite($f,"Error msg: $msg\n");
			fwrite($f,"Error file: $errfile\n");
			fwrite($f,"Error line: $errline\n");
			fwrite($f,"=================\n");
			fclose($f);
			@chmod($file,0666);
		endif;
	endif;
	$msg = "(code $code) Error in $errfile:$errline message:\"$msg\"";
	tolog('-',$msg);
}

class C_LOG
{
	var $file;
	var $lvls;
	var $br;
	var $stdout;
	var $filename;

	function C_LOG($fname,$lvls,$br)
	{
		GLOBAL $CONFIG;
		$this->stdout = (strcasecmp($fname,'stdout')==0);
		$this->lvls = $lvls;
		$br = str_replace('\r',"\r",$br);
		$br = str_replace('\n',"\n",$br);
		$this->br = $br;
		$this->filename = $fname;
		if (!$this->stdout && (!$this->file = fopen($fname,'a')))
			{ die("Open log file \"$fname\" failed!"); }

			$Time=date("r");
			$this->write('1'," *** Started: $Time ({$CONFIG->Constants['module']}/".VERSION.")");
	}
	
	function write($lvl,$message)
	{
		if (strpos($this->lvls,$lvl)!==false):
			$date = date("d M, H:i:s");
			if ($this->stdout):
				print("$lvl $date $message".$this->br);
			else:
				fwrite($this->file,"$lvl $date $message".$this->br);
			endif;	
		endif;
	}

	function done()
	{
		$Time=date("r, t");
		$this->write('1'," *** End: $Time");
		if (!$this->stdout) { 
			fclose($this->file); 
			@chmod($this->filename,0666);
		}
	}

	function refseek()
	{
		if (!$this->stdout):
		fseek($this->file,0,SEEK_END);
		endif;
	}
}

function initlog()
{
	GLOBAL $CONFIG, $LOGS, $LOGS_active;
	$LOGS = array();
	if (isset($CONFIG) && ($arr = $CONFIG->GetArray('logfile'))):
		foreach ($arr as $logfile):
			$logfarr = param_split($logfile);
			$fname = $logfarr[0];
			$lvls = isset($logfarr[1])?$logfarr[1]:'';
			$br = isset($logfarr[2])?$logfarr[2]:'\n';
			$LOGS[] = new C_LOG($fname,$lvls,$br);
		endforeach;
	endif;
	$LOGS_active = true;
}

function tolog($lvl,$message)
{
	GLOBAL $LOGS, $LOGS_active;
	if ($LOGS_active):
		for ($i=0;$i<sizeof($LOGS);$i++):
			$LOGS[$i]->write($lvl,$message);
		endfor;
	endif;
}

function donelog()
{
	GLOBAL $LOGS, $LOGS_active;
	if ($LOGS_active):
		for($i=0;$i<sizeof($LOGS);$i++):
			$LOGS[$i]->done();
			$LOGS[$i] = false;
		endfor;
		$LOGS_active = false;
	endif;
	$LOGS = array();
}

function refseeklog()
{
GLOBAL $LOGS;
for($i=0;$i<sizeof($LOGS);$i++) { $LOGS[$i]->refseek(); }
}

?>
